<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1">

<link href="/static/css/bootstrap.min.css" rel="stylesheet">
<link href="/static/css/datepicker3.css" rel="stylesheet">
<link href="/static/css/styles.css" rel="stylesheet">
<link href="/static/css/bootstrap-table.css" rel="stylesheet">

<!--[if lt IE 9]>
<script src="/static/js/html5shiv.js"></script>
<script src="/static/js/respond.min.js"></script>
<![endif]-->
<script src="https://api.mapy.cz/loader.js"></script>
<script>
	if(typeof(Loader) != "undefined") Loader.load()
</script>

<title>AA4CC - Experiment master</title>
</head>

<body>
	<nav class="navbar navbar-inverse navbar-fixed-top" role="navigation">
		<div class="container-fluid">
			<div class="navbar-header">
				<a class="navbar-brand" href="/"><span>AA4CC</span> Car ACC experiment</a>
			</div>
							
		</div><!-- /.container-fluid -->
	</nav>
		
	<div class="main container-fluid">	
		{% with messages = get_flashed_messages() %}
		  {% if messages %}
		  	<div>
		  	
		    {% for message in messages %}
				<div class="alert alert-warning">
					{{ message }}
				</div>
		    {% endfor %}
		    </div>
		  {% endif %}
		{% endwith %}

		<div class="row">
			<div class="col-lg-12">
				<h1>Master control</h1>
			</div>
		</div><!--/.row-->
		<div class="col-lg-6">
			<div class="row">
				<div class="col-lg-12">
					<h3>Pokyny</h3>
					<p id="instructions" style="height: 150px">
						Zde se objeví poslední vydaný pokyn
					</p>
				</div>
			</div>
			<div class="row">
				<div class="col-lg-12">
					<h3>Pokyny</h3>
					<textarea id="text" name="text" style="width: 100%; height: 100px"></textarea><br/>
					<button class="btn btn-primary send-instructions" type="submit">
							Vydat pokyn
					</button>
				</div>
			</div>
			<div class="row">
				<div class="col-lg-12">
					<h3>Monitoring</h3>
					<table class="table">
						<tr>
							<th>Vozidlo</th>
							<th>GPS</th>
							<th>dGPS</th>
							<th>Relativní vzdálenost</th>
							<th>Rychlost</th>
						</tr>
						<tbody id="monitoring-body">
							<tr><td colspan=3>Žádná data</td></tr>
						</tbody>
					</table>
				</div>
			</div>
		</div>
		<div class="row">
			<div class="col-lg-6">
					<button class="btn btn-default open-map" type="submit">
							Otevřít mapu
					</button>
				<div id="mapa" style="width:100%; height:400px;"></div>
			</div>
		</div>
	</div>	<!--/.main-->

	<script src="/static/js/jquery-1.11.1.min.js"></script>
	<script src="/static/js/bootstrap.min.js"></script>	
	<script src="/static/js/bootstrap-table.js"></script>
	<script>
		!function ($) {
		    $(document).on("click","ul.nav li.parent > a > span.icon", function(){          
		        $(this).find('em:first').toggleClass("glyphicon-minus");      
		    }); 
		    $(".sidebar span.icon").find('em:first').addClass("glyphicon-plus");
		}(window.jQuery);

		$(window).on('resize', function () {
		  if ($(window).width() > 768) $('#sidebar-collapse').collapse('show')
		})
		$(window).on('resize', function () {
		  if ($(window).width() <= 767) $('#sidebar-collapse').collapse('hide')
		})

		function marker(number, name, lat, lon){
			var znacka = JAK.mel("div");
				var obrazek = JAK.mel("img", {src:SMap.CONFIG.img+"/marker/drop-red.png"});
				znacka.appendChild(obrazek);

				var popisek = JAK.mel("div", {}, {position:"absolute", left:"0px", top:"2px", textAlign:"center", width:"22px", color:"white", fontWeight:"bold"});
				popisek.innerHTML = number;
				znacka.appendChild(popisek);

				return new SMap.Marker(SMap.Coords.fromWGS84(lon, lat), name, {title: name, url: znacka});
		}

		window.mapa = undefined
		function createMap(){
			if(typeof(SMap) != "undefined"){
				var stred = SMap.Coords.fromWGS84(14.4176147, 50.0768546);
				window.mapa = new SMap(JAK.gel("mapa"), stred,18);
				mapa.addDefaultLayer(SMap.DEF_TURIST).enable();
				mapa.addDefaultControls();

				window.layer = new SMap.Layer.Marker();
				mapa.addLayer(layer).enable();

				var sync = new SMap.Control.Sync({bottomSpace:30});
				mapa.addControl(sync);
			}
		}

		function load() {
			Loader.async = true;
			Loader.load(null, null, createMap);
		}

		$(function(){
			window.master = new EventSource('/instructions?monitoring=True')
			window.master.addEventListener('message', function(event){
                $("#instructions").text(event.data)
            })
			window.master.addEventListener('open', function(){
				console.log("Master connection")
			})

			window.master.addEventListener('monitoring', function(event){
				window.monitoring = JSON.parse(event.data)
				$("#monitoring-body").text("")
				if(typeof(window.layer) != "undefined"){
					layer.removeAll()
				}
				Object.keys(monitoring).forEach(function(key) {
		
					console.log(key, monitoring[key]);
					element = monitoring[key]
					row = $("<tr>")
					row.append($("<td>").text(key))
					row.append($("<td>").text("("+element.position.latitude+","+element.position.longitude+")"))
					row.append($("<td>").text(element.relative_position.Valid))
					row.append($("<td>").text(element.relative_position.Length+"(± "+element.relative_position.LengthAcc+' m)'))
					row.append($("<td>").text(Math.round(element.position.groundSpeed*3.6) + ' km/h'))
					row.appendTo($("#monitoring-body"))

					if(typeof(window.layer) != "undefined"){
						if(key == "leader"){
							id = "L"
							window.mapa.setCenter(SMap.Coords.fromWGS84(element.position.longitude, element.position.latitude))
						}else{
							id = key.split('-')[0].substr(3)
						}
						window.layer.addMarker(marker(id, key, element.position.latitude, element.position.longitude))
					}
				});
			})

			$('.open-map').click(load)


			

			$('.send-instructions').click(function(){
				$.post(
                    '/instructions',
					{"text": $("#text").val()}
				).fail(function(data){
					alert('Error: '+data.responseText)
				})
			})
		})
	</script>	
</body>

</html>
